'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const EventTypes_1 = require("./EventTypes/EventTypes");
const Middleware_1 = require("./Middleware/Middleware");
const ReadModel_1 = require("./ReadModel/ReadModel");
var EventStore;
(function (EventStore) {
    EventStore.EventTypes = EventTypes_1.EventTypes;
    EventStore.ReadModel = ReadModel_1.ReadModel;
    EventStore.writeTransmuteCommand = (eventStore, fromAddress, transmuteCommand) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        return yield Middleware_1.Middleware.writeTransmuteCommand(eventStore, fromAddress, transmuteCommand);
    });
    EventStore.writeTransmuteCommands = (eventStore, fromAddress, transmuteCommands) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        return yield Middleware_1.Middleware.writeTransmuteCommands(eventStore, fromAddress, transmuteCommands);
    });
    EventStore.readTransmuteEvent = (eventStore, fromAddress, eventId) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        return Middleware_1.Middleware.readTransmuteEvent(eventStore, fromAddress, eventId);
    });
    EventStore.readTransmuteEvents = (eventStore, fromAddress, eventId) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        return Middleware_1.Middleware.readTransmuteEvents(eventStore, fromAddress, eventId);
    });
})(EventStore = exports.EventStore || (exports.EventStore = {}));
