"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Middleware_1 = require("../Middleware/Middleware");
const Persistence_1 = require("../Persistence/Persistence");
var ReadModel;
(function (ReadModel) {
    ReadModel.readModelGenerator = (readModel, reducer, events) => {
        events.forEach((event) => {
            readModel = reducer(readModel, event);
        });
        return readModel;
    };
    ReadModel.maybeSyncReadModel = (eventStore, fromAddress, readModel, reducer) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        let solidityEventCount = (yield eventStore.solidityEventCount()).toNumber();
        return Persistence_1.Persistence.LocalStore.getItem(readModel.readModelStoreKey)
            .then((_readModel) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            if (!_readModel) {
                _readModel = readModel;
            }
            if (_readModel.lastEvent === solidityEventCount) {
                return readModel;
            }
            let events = yield Middleware_1.Middleware.readTransmuteEvents(eventStore, fromAddress, _readModel.lastEvent || 0);
            let updatedReadModel = ReadModel.readModelGenerator(_readModel, reducer, events);
            return Persistence_1.Persistence.LocalStore.setItem(updatedReadModel.readModelStoreKey, updatedReadModel);
        }));
    });
})(ReadModel = exports.ReadModel || (exports.ReadModel = {}));
